"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .countrycodeenum import CountryCodeEnum
from .currencyenum import CurrencyEnum
from .nexusstateenum import NexusStateEnum
from .nexusstatusenum import NexusStatusEnum
from .nexustypeenum import NexusTypeEnum
from .periodmodelenum import PeriodModelEnum
from .registrationsregimeenum import RegistrationsRegimeEnum
from .salesortransactionsenum import SalesOrTransactionsEnum
from .treatmentenum import TreatmentEnum
from datetime import date, datetime
from kintsugi_tax_platform_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from kintsugi_tax_platform_sdk.utils import parse_datetime
import pydantic
from pydantic import model_serializer
from typing import Any, Dict, List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class NexusResponseTypedDict(TypedDict):
    country_code: CountryCodeEnum
    state_code: str
    state_name: str
    treatment_of_exempt_transactions: TreatmentEnum
    trigger: str
    sales_or_transactions: SalesOrTransactionsEnum
    threshold_sales: int
    threshold_transactions: Nullable[int]
    start_date: date
    period_model: PeriodModelEnum
    period_start_date: date
    period_end_date: date
    previous_period_start_date: Nullable[date]
    previous_period_end_date: Nullable[date]
    id: str
    created_at: datetime
    updated_at: datetime
    organization_id: str
    is_vda_eligible: bool
    nexus_type: NexusTypeEnum
    total_transactions: int
    total_transactions_included: int
    total_transactions_exempted: int
    total_transactions_marketplace: int
    processing_status: NotRequired[NexusStatusEnum]
    status: NotRequired[NexusStateEnum]
    transaction_count: NotRequired[int]
    transactions_amount: NotRequired[str]
    previous_transaction_count: NotRequired[int]
    r"""Deprecated: transaction_count now includes both current and previous period values when period_model is CURRENT_OR_PREVIOUS"""
    previous_transactions_amount: NotRequired[str]
    r"""Deprecated: transactions_amount now includes both current and previous period values when period_model is CURRENT_OR_PREVIOUS"""
    calculated_tax_liability: NotRequired[Nullable[str]]
    imported_tax_liability: NotRequired[Nullable[str]]
    tax_liability: NotRequired[str]
    nexus_met: NotRequired[bool]
    nexus_met_date: NotRequired[Nullable[date]]
    economic_nexus_met: NotRequired[bool]
    economic_nexus_met_date: NotRequired[Nullable[date]]
    physical_nexus_met: NotRequired[bool]
    physical_nexus_met_date: NotRequired[Nullable[date]]
    collected_tax_nexus_met: NotRequired[Nullable[bool]]
    collected_tax_nexus_met_date: NotRequired[Nullable[date]]
    collected_tax_enabled: NotRequired[bool]
    earliest_transaction_date: NotRequired[Nullable[datetime]]
    most_recent_transaction_date: NotRequired[Nullable[datetime]]
    earliest_collected_date: NotRequired[datetime]
    predicted_month_from_today: NotRequired[Nullable[int]]
    vda_eligible: NotRequired[Nullable[bool]]
    confidence_level: NotRequired[Nullable[float]]
    last_processed_at: NotRequired[Nullable[datetime]]
    last_tax_liability_processed_at: NotRequired[Nullable[datetime]]
    periods: NotRequired[Nullable[List[Dict[str, Any]]]]
    currency: NotRequired[Nullable[CurrencyEnum]]
    r"""Currency code for the nexus (e.g., USD, CAD)."""
    registration: NotRequired[Nullable[Dict[str, Any]]]
    registration_regime: NotRequired[Nullable[RegistrationsRegimeEnum]]


class NexusResponse(BaseModel):
    country_code: CountryCodeEnum

    state_code: str

    state_name: str

    treatment_of_exempt_transactions: TreatmentEnum

    trigger: str

    sales_or_transactions: SalesOrTransactionsEnum

    threshold_sales: int

    threshold_transactions: Nullable[int]

    start_date: date

    period_model: PeriodModelEnum

    period_start_date: date

    period_end_date: date

    previous_period_start_date: Nullable[date]

    previous_period_end_date: Nullable[date]

    id: str

    created_at: datetime

    updated_at: datetime

    organization_id: str

    is_vda_eligible: bool

    nexus_type: NexusTypeEnum

    total_transactions: int

    total_transactions_included: int

    total_transactions_exempted: int

    total_transactions_marketplace: int

    processing_status: Optional[NexusStatusEnum] = None

    status: Optional[NexusStateEnum] = None

    transaction_count: Optional[int] = 0

    transactions_amount: Optional[str] = "0.00"

    previous_transaction_count: Annotated[
        Optional[int],
        pydantic.Field(
            deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible."
        ),
    ] = 0
    r"""Deprecated: transaction_count now includes both current and previous period values when period_model is CURRENT_OR_PREVIOUS"""

    previous_transactions_amount: Annotated[
        Optional[str],
        pydantic.Field(
            deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible."
        ),
    ] = "0.00"
    r"""Deprecated: transactions_amount now includes both current and previous period values when period_model is CURRENT_OR_PREVIOUS"""

    calculated_tax_liability: OptionalNullable[str] = UNSET

    imported_tax_liability: OptionalNullable[str] = UNSET

    tax_liability: Optional[str] = "0.00"

    nexus_met: Optional[bool] = False

    nexus_met_date: OptionalNullable[date] = UNSET

    economic_nexus_met: Optional[bool] = False

    economic_nexus_met_date: OptionalNullable[date] = UNSET

    physical_nexus_met: Optional[bool] = False

    physical_nexus_met_date: OptionalNullable[date] = UNSET

    collected_tax_nexus_met: OptionalNullable[bool] = UNSET

    collected_tax_nexus_met_date: OptionalNullable[date] = UNSET

    collected_tax_enabled: Optional[bool] = False

    earliest_transaction_date: OptionalNullable[datetime] = UNSET

    most_recent_transaction_date: OptionalNullable[datetime] = UNSET

    earliest_collected_date: Optional[datetime] = parse_datetime("2018-01-01T00:00:00")

    predicted_month_from_today: OptionalNullable[int] = UNSET

    vda_eligible: OptionalNullable[bool] = UNSET

    confidence_level: OptionalNullable[float] = UNSET

    last_processed_at: OptionalNullable[datetime] = UNSET

    last_tax_liability_processed_at: OptionalNullable[datetime] = UNSET

    periods: OptionalNullable[List[Dict[str, Any]]] = UNSET

    currency: OptionalNullable[CurrencyEnum] = UNSET
    r"""Currency code for the nexus (e.g., USD, CAD)."""

    registration: OptionalNullable[Dict[str, Any]] = UNSET

    registration_regime: OptionalNullable[RegistrationsRegimeEnum] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "processing_status",
            "status",
            "transaction_count",
            "transactions_amount",
            "previous_transaction_count",
            "previous_transactions_amount",
            "calculated_tax_liability",
            "imported_tax_liability",
            "tax_liability",
            "nexus_met",
            "nexus_met_date",
            "economic_nexus_met",
            "economic_nexus_met_date",
            "physical_nexus_met",
            "physical_nexus_met_date",
            "collected_tax_nexus_met",
            "collected_tax_nexus_met_date",
            "collected_tax_enabled",
            "earliest_transaction_date",
            "most_recent_transaction_date",
            "earliest_collected_date",
            "predicted_month_from_today",
            "vda_eligible",
            "confidence_level",
            "last_processed_at",
            "last_tax_liability_processed_at",
            "periods",
            "currency",
            "registration",
            "registration_regime",
        ]
        nullable_fields = [
            "threshold_transactions",
            "calculated_tax_liability",
            "imported_tax_liability",
            "nexus_met_date",
            "economic_nexus_met_date",
            "physical_nexus_met_date",
            "collected_tax_nexus_met",
            "collected_tax_nexus_met_date",
            "previous_period_start_date",
            "previous_period_end_date",
            "earliest_transaction_date",
            "most_recent_transaction_date",
            "predicted_month_from_today",
            "vda_eligible",
            "confidence_level",
            "last_processed_at",
            "last_tax_liability_processed_at",
            "periods",
            "currency",
            "registration",
            "registration_regime",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
