"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .currencyenum import CurrencyEnum
from .customerbasepublic import CustomerBasePublic, CustomerBasePublicTypedDict
from .sourceenum import SourceEnum
from .transactionitemestimatebase import (
    TransactionItemEstimateBase,
    TransactionItemEstimateBaseTypedDict,
)
from datetime import datetime
from enum import Enum
from kintsugi_tax_platform_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
import pydantic
from pydantic import model_serializer
from typing import List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


TotalAmountOfTheTransactionAfterDiscountsTypedDict = TypeAliasType(
    "TotalAmountOfTheTransactionAfterDiscountsTypedDict", Union[float, str]
)
r"""Total amount of the transaction."""


TotalAmountOfTheTransactionAfterDiscounts = TypeAliasType(
    "TotalAmountOfTheTransactionAfterDiscounts", Union[float, str]
)
r"""Total amount of the transaction."""


class TransactionEstimatePublicRequestType(str, Enum):
    r"""Type of the address. Must be either
    SHIP_TO or BILL_TO.
    """

    SHIP_TO = "SHIP_TO"
    BILL_TO = "BILL_TO"


class TransactionEstimatePublicRequestAddressTypedDict(TypedDict):
    type: TransactionEstimatePublicRequestType
    r"""Type of the address. Must be either
    SHIP_TO or BILL_TO.
    """
    state: str
    r"""State or province of the address."""
    postal_code: str
    r"""Postal code of the address."""
    country: str
    r"""Country of the address."""
    phone: NotRequired[str]
    r"""Phone number associated with the customer."""
    street_1: NotRequired[str]
    r"""Primary street address of the customer."""
    street_2: NotRequired[str]
    r"""Additional street address details, such as an apartment or suite number."""
    city: NotRequired[str]
    r"""City where the customer resides."""
    county: NotRequired[str]
    r"""County or district of the customer."""
    full_address: NotRequired[str]
    r"""Complete address string of the customer, which can be used as an alternative to individual fields."""
    status: NotRequired[str]
    r"""Status of the address. Deprecated and ignored."""


class TransactionEstimatePublicRequestAddress(BaseModel):
    type: TransactionEstimatePublicRequestType
    r"""Type of the address. Must be either
    SHIP_TO or BILL_TO.
    """

    state: str
    r"""State or province of the address."""

    postal_code: str
    r"""Postal code of the address."""

    country: str
    r"""Country of the address."""

    phone: Optional[str] = None
    r"""Phone number associated with the customer."""

    street_1: Optional[str] = None
    r"""Primary street address of the customer."""

    street_2: Optional[str] = None
    r"""Additional street address details, such as an apartment or suite number."""

    city: Optional[str] = None
    r"""City where the customer resides."""

    county: Optional[str] = None
    r"""County or district of the customer."""

    full_address: Optional[str] = None
    r"""Complete address string of the customer, which can be used as an alternative to individual fields."""

    status: Annotated[
        Optional[str],
        pydantic.Field(
            deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible."
        ),
    ] = None
    r"""Status of the address. Deprecated and ignored."""


class TransactionEstimatePublicRequestTypedDict(TypedDict):
    r"""Public request model for tax estimation API documentation.
    This model excludes internal fields like enriched_fields that should not be exposed in API docs.
    """

    date_: datetime
    r"""The date of the transaction in ISO 8601 format (e.g., 2025-01-25T12:00:00Z)."""
    external_id: str
    r"""Unique identifier of this transaction in the source system."""
    currency: CurrencyEnum
    transaction_items: List[TransactionItemEstimateBaseTypedDict]
    r"""List of items involved in the transaction."""
    addresses: List[TransactionEstimatePublicRequestAddressTypedDict]
    r"""List of addresses related to the transaction. At least one BILL_TO or SHIP_TO address must be provided. The address will be validated during estimation, and the transaction may be rejected if the address does not pass validation. The SHIP_TO will be preferred to use for determining tax liability."""
    total_amount: NotRequired[TotalAmountOfTheTransactionAfterDiscountsTypedDict]
    r"""Total amount of the transaction."""
    description: NotRequired[Nullable[str]]
    r"""An optional description of the transaction."""
    source: NotRequired[Nullable[SourceEnum]]
    r"""While currently not used, it may be used in the future to determine taxability. The source of the transaction (e.g., OTHER)."""
    marketplace: NotRequired[Nullable[bool]]
    r"""Indicates if the transaction involves a marketplace."""
    customer: NotRequired[Nullable[CustomerBasePublicTypedDict]]
    r"""Details about the customer. If the customer is not found, it will be ignored."""


class TransactionEstimatePublicRequest(BaseModel):
    r"""Public request model for tax estimation API documentation.
    This model excludes internal fields like enriched_fields that should not be exposed in API docs.
    """

    date_: Annotated[datetime, pydantic.Field(alias="date")]
    r"""The date of the transaction in ISO 8601 format (e.g., 2025-01-25T12:00:00Z)."""

    external_id: str
    r"""Unique identifier of this transaction in the source system."""

    currency: CurrencyEnum

    transaction_items: List[TransactionItemEstimateBase]
    r"""List of items involved in the transaction."""

    addresses: List[TransactionEstimatePublicRequestAddress]
    r"""List of addresses related to the transaction. At least one BILL_TO or SHIP_TO address must be provided. The address will be validated during estimation, and the transaction may be rejected if the address does not pass validation. The SHIP_TO will be preferred to use for determining tax liability."""

    total_amount: Optional[TotalAmountOfTheTransactionAfterDiscounts] = None
    r"""Total amount of the transaction."""

    description: OptionalNullable[str] = UNSET
    r"""An optional description of the transaction."""

    source: Annotated[
        OptionalNullable[SourceEnum],
        pydantic.Field(
            deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible."
        ),
    ] = UNSET
    r"""While currently not used, it may be used in the future to determine taxability. The source of the transaction (e.g., OTHER)."""

    marketplace: OptionalNullable[bool] = UNSET
    r"""Indicates if the transaction involves a marketplace."""

    customer: OptionalNullable[CustomerBasePublic] = UNSET
    r"""Details about the customer. If the customer is not found, it will be ignored."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "total_amount",
            "description",
            "source",
            "marketplace",
            "customer",
        ]
        nullable_fields = ["description", "source", "marketplace", "customer"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
