"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .currencyenum import CurrencyEnum
from .discountbuilder import DiscountBuilder, DiscountBuilderTypedDict
from .taxexemptionenum import TaxExemptionEnum
from .taxitembuilder import TaxItemBuilder, TaxItemBuilderTypedDict
from datetime import datetime
from kintsugi_tax_platform_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
import pydantic
from pydantic import model_serializer
from typing import List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


TransactionItemBuilderQuantityTypedDict = TypeAliasType(
    "TransactionItemBuilderQuantityTypedDict", Union[float, str]
)
r"""Quantity of item."""


TransactionItemBuilderQuantity = TypeAliasType(
    "TransactionItemBuilderQuantity", Union[float, str]
)
r"""Quantity of item."""


TransactionItemBuilderAmountTypedDict = TypeAliasType(
    "TransactionItemBuilderAmountTypedDict", Union[float, str]
)
r"""Item amount."""


TransactionItemBuilderAmount = TypeAliasType(
    "TransactionItemBuilderAmount", Union[float, str]
)
r"""Item amount."""


TransactionItemBuilderTaxAmountImportedTypedDict = TypeAliasType(
    "TransactionItemBuilderTaxAmountImportedTypedDict", Union[float, str]
)
r"""Imported tax amount for the item."""


TransactionItemBuilderTaxAmountImported = TypeAliasType(
    "TransactionItemBuilderTaxAmountImported", Union[float, str]
)
r"""Imported tax amount for the item."""


TransactionItemBuilderTaxRateImportedTypedDict = TypeAliasType(
    "TransactionItemBuilderTaxRateImportedTypedDict", Union[float, str]
)
r"""Imported tax rate."""


TransactionItemBuilderTaxRateImported = TypeAliasType(
    "TransactionItemBuilderTaxRateImported", Union[float, str]
)
r"""Imported tax rate."""


TransactionItemBuilderTaxAmountCalculatedTypedDict = TypeAliasType(
    "TransactionItemBuilderTaxAmountCalculatedTypedDict", Union[float, str]
)
r"""Calculated tax amount for the item."""


TransactionItemBuilderTaxAmountCalculated = TypeAliasType(
    "TransactionItemBuilderTaxAmountCalculated", Union[float, str]
)
r"""Calculated tax amount for the item."""


TransactionItemBuilderTaxRateCalculatedTypedDict = TypeAliasType(
    "TransactionItemBuilderTaxRateCalculatedTypedDict", Union[float, str]
)
r"""Calculated tax rate."""


TransactionItemBuilderTaxRateCalculated = TypeAliasType(
    "TransactionItemBuilderTaxRateCalculated", Union[float, str]
)
r"""Calculated tax rate."""


TransactionItemBuilderConvertedAmountTypedDict = TypeAliasType(
    "TransactionItemBuilderConvertedAmountTypedDict", Union[float, str]
)
r"""Converted item amount."""


TransactionItemBuilderConvertedAmount = TypeAliasType(
    "TransactionItemBuilderConvertedAmount", Union[float, str]
)
r"""Converted item amount."""


TransactionItemBuilderConvertedTaxableAmountTypedDict = TypeAliasType(
    "TransactionItemBuilderConvertedTaxableAmountTypedDict", Union[float, str]
)
r"""Converted taxable amount."""


TransactionItemBuilderConvertedTaxableAmount = TypeAliasType(
    "TransactionItemBuilderConvertedTaxableAmount", Union[float, str]
)
r"""Converted taxable amount."""


TransactionItemBuilderConvertedTaxAmountImportedTypedDict = TypeAliasType(
    "TransactionItemBuilderConvertedTaxAmountImportedTypedDict", Union[float, str]
)
r"""Converted imported tax amount."""


TransactionItemBuilderConvertedTaxAmountImported = TypeAliasType(
    "TransactionItemBuilderConvertedTaxAmountImported", Union[float, str]
)
r"""Converted imported tax amount."""


TransactionItemBuilderConvertedTaxAmountCalculatedTypedDict = TypeAliasType(
    "TransactionItemBuilderConvertedTaxAmountCalculatedTypedDict", Union[float, str]
)
r"""Converted calculated tax amount"""


TransactionItemBuilderConvertedTaxAmountCalculated = TypeAliasType(
    "TransactionItemBuilderConvertedTaxAmountCalculated", Union[float, str]
)
r"""Converted calculated tax amount"""


TransactionItemBuilderConvertedTotalDiscountTypedDict = TypeAliasType(
    "TransactionItemBuilderConvertedTotalDiscountTypedDict", Union[float, str]
)
r"""Converted total discount amount."""


TransactionItemBuilderConvertedTotalDiscount = TypeAliasType(
    "TransactionItemBuilderConvertedTotalDiscount", Union[float, str]
)
r"""Converted total discount amount."""


TransactionItemBuilderConvertedSubtotalTypedDict = TypeAliasType(
    "TransactionItemBuilderConvertedSubtotalTypedDict", Union[float, str]
)
r"""Converted subtotal amount."""


TransactionItemBuilderConvertedSubtotal = TypeAliasType(
    "TransactionItemBuilderConvertedSubtotal", Union[float, str]
)
r"""Converted subtotal amount."""


TransactionItemBuilderTaxableAmountTypedDict = TypeAliasType(
    "TransactionItemBuilderTaxableAmountTypedDict", Union[float, str]
)
r"""Taxable amount for the item."""


TransactionItemBuilderTaxableAmount = TypeAliasType(
    "TransactionItemBuilderTaxableAmount", Union[float, str]
)
r"""Taxable amount for the item."""


class TransactionItemBuilderTypedDict(TypedDict):
    organization_id: Nullable[str]
    r"""Organization identifier."""
    date_: datetime
    r"""Date/time of item."""
    external_product_id: str
    r"""External product identifier."""
    external_id: NotRequired[Nullable[str]]
    r"""External item identifier."""
    description: NotRequired[Nullable[str]]
    r"""Item description"""
    product: NotRequired[Nullable[str]]
    r"""Product name"""
    product_id: NotRequired[Nullable[str]]
    r"""Product identifier."""
    product_name: NotRequired[Nullable[str]]
    r"""Product name (detailed)"""
    product_description: NotRequired[Nullable[str]]
    r"""Product description"""
    quantity: NotRequired[TransactionItemBuilderQuantityTypedDict]
    r"""Quantity of item."""
    amount: NotRequired[TransactionItemBuilderAmountTypedDict]
    r"""Item amount."""
    tax_amount_imported: NotRequired[TransactionItemBuilderTaxAmountImportedTypedDict]
    r"""Imported tax amount for the item."""
    tax_rate_imported: NotRequired[TransactionItemBuilderTaxRateImportedTypedDict]
    r"""Imported tax rate."""
    tax_amount_calculated: NotRequired[
        TransactionItemBuilderTaxAmountCalculatedTypedDict
    ]
    r"""Calculated tax amount for the item."""
    tax_rate_calculated: NotRequired[TransactionItemBuilderTaxRateCalculatedTypedDict]
    r"""Calculated tax rate."""
    original_currency: NotRequired[Nullable[CurrencyEnum]]
    r"""Original currency code."""
    destination_currency: NotRequired[Nullable[CurrencyEnum]]
    r"""Destination currency code."""
    converted_amount: NotRequired[
        Nullable[TransactionItemBuilderConvertedAmountTypedDict]
    ]
    r"""Converted item amount."""
    converted_taxable_amount: NotRequired[
        Nullable[TransactionItemBuilderConvertedTaxableAmountTypedDict]
    ]
    r"""Converted taxable amount."""
    converted_tax_amount_imported: NotRequired[
        Nullable[TransactionItemBuilderConvertedTaxAmountImportedTypedDict]
    ]
    r"""Converted imported tax amount."""
    converted_tax_amount_calculated: NotRequired[
        Nullable[TransactionItemBuilderConvertedTaxAmountCalculatedTypedDict]
    ]
    r"""Converted calculated tax amount"""
    converted_total_discount: NotRequired[
        Nullable[TransactionItemBuilderConvertedTotalDiscountTypedDict]
    ]
    r"""Converted total discount amount."""
    converted_subtotal: NotRequired[
        Nullable[TransactionItemBuilderConvertedSubtotalTypedDict]
    ]
    r"""Converted subtotal amount."""
    taxable_amount: NotRequired[TransactionItemBuilderTaxableAmountTypedDict]
    r"""Taxable amount for the item."""
    tax_exemption: NotRequired[Nullable[TaxExemptionEnum]]
    r"""Tax exemption status."""
    exempt: NotRequired[bool]
    r"""Indicates if the item is exempt."""
    tax_items: NotRequired[List[TaxItemBuilderTypedDict]]
    discount_builder: NotRequired[Nullable[DiscountBuilderTypedDict]]


class TransactionItemBuilder(BaseModel):
    organization_id: Nullable[str]
    r"""Organization identifier."""

    date_: Annotated[datetime, pydantic.Field(alias="date")]
    r"""Date/time of item."""

    external_product_id: str
    r"""External product identifier."""

    external_id: OptionalNullable[str] = UNSET
    r"""External item identifier."""

    description: OptionalNullable[str] = UNSET
    r"""Item description"""

    product: OptionalNullable[str] = UNSET
    r"""Product name"""

    product_id: OptionalNullable[str] = UNSET
    r"""Product identifier."""

    product_name: OptionalNullable[str] = UNSET
    r"""Product name (detailed)"""

    product_description: OptionalNullable[str] = UNSET
    r"""Product description"""

    quantity: Optional[TransactionItemBuilderQuantity] = None
    r"""Quantity of item."""

    amount: Optional[TransactionItemBuilderAmount] = None
    r"""Item amount."""

    tax_amount_imported: Optional[TransactionItemBuilderTaxAmountImported] = None
    r"""Imported tax amount for the item."""

    tax_rate_imported: Optional[TransactionItemBuilderTaxRateImported] = None
    r"""Imported tax rate."""

    tax_amount_calculated: Optional[TransactionItemBuilderTaxAmountCalculated] = None
    r"""Calculated tax amount for the item."""

    tax_rate_calculated: Optional[TransactionItemBuilderTaxRateCalculated] = None
    r"""Calculated tax rate."""

    original_currency: OptionalNullable[CurrencyEnum] = UNSET
    r"""Original currency code."""

    destination_currency: OptionalNullable[CurrencyEnum] = UNSET
    r"""Destination currency code."""

    converted_amount: OptionalNullable[TransactionItemBuilderConvertedAmount] = UNSET
    r"""Converted item amount."""

    converted_taxable_amount: OptionalNullable[
        TransactionItemBuilderConvertedTaxableAmount
    ] = UNSET
    r"""Converted taxable amount."""

    converted_tax_amount_imported: OptionalNullable[
        TransactionItemBuilderConvertedTaxAmountImported
    ] = UNSET
    r"""Converted imported tax amount."""

    converted_tax_amount_calculated: OptionalNullable[
        TransactionItemBuilderConvertedTaxAmountCalculated
    ] = UNSET
    r"""Converted calculated tax amount"""

    converted_total_discount: OptionalNullable[
        TransactionItemBuilderConvertedTotalDiscount
    ] = UNSET
    r"""Converted total discount amount."""

    converted_subtotal: OptionalNullable[TransactionItemBuilderConvertedSubtotal] = (
        UNSET
    )
    r"""Converted subtotal amount."""

    taxable_amount: Optional[TransactionItemBuilderTaxableAmount] = None
    r"""Taxable amount for the item."""

    tax_exemption: OptionalNullable[TaxExemptionEnum] = UNSET
    r"""Tax exemption status."""

    exempt: Optional[bool] = False
    r"""Indicates if the item is exempt."""

    tax_items: Optional[List[TaxItemBuilder]] = None

    discount_builder: OptionalNullable[DiscountBuilder] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "external_id",
            "description",
            "product",
            "product_id",
            "product_name",
            "product_description",
            "quantity",
            "amount",
            "tax_amount_imported",
            "tax_rate_imported",
            "tax_amount_calculated",
            "tax_rate_calculated",
            "original_currency",
            "destination_currency",
            "converted_amount",
            "converted_taxable_amount",
            "converted_tax_amount_imported",
            "converted_tax_amount_calculated",
            "converted_total_discount",
            "converted_subtotal",
            "taxable_amount",
            "tax_exemption",
            "exempt",
            "tax_items",
            "discount_builder",
        ]
        nullable_fields = [
            "external_id",
            "organization_id",
            "description",
            "product",
            "product_id",
            "product_name",
            "product_description",
            "original_currency",
            "destination_currency",
            "converted_amount",
            "converted_taxable_amount",
            "converted_tax_amount_imported",
            "converted_tax_amount_calculated",
            "converted_total_discount",
            "converted_subtotal",
            "tax_exemption",
            "discount_builder",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
